part of masamune;

@immutable
class LocalModuleAdapter extends ModuleAdapter<
    LocalDynamicDocumentModel,
    LocalDynamicCollectionModel,
    ModelProvider<LocalDynamicDocumentModel>,
    ModelProvider<LocalDynamicCollectionModel>> {
  const LocalModuleAdapter();

  @override
  T collectionProvider<T extends ModelProvider<LocalDynamicCollectionModel>>(
          String path) =>
      localCollectionProvider(path) as T;

  @override
  T documentProvider<T extends ModelProvider<LocalDynamicDocumentModel>>(
          String path) =>
      localDocumentProvider(path) as T;

  @override
  LocalDynamicDocumentModel loadDocument(LocalDynamicDocumentModel document) {
    return document..loadOnce();
  }

  @override
  LocalDynamicCollectionModel loadCollection(
      LocalDynamicCollectionModel collection) {
    return collection..loadOnce();
  }

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool enabledAuth = false;

  @override
  Future<void> registerInEmailAndPassword(
      {required String email, required String password}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> sendPasswordResetEmail({required String email}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signInAnonymously() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signInEmailAndPassword(
      {required String email, required String password}) {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> signOut() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  Future<void> tryRestoreAuth() {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get email {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isAnonymously = true;

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isSignedIn = true;

  @override
  // ignore: avoid_field_initializers_in_const_classes
  final bool isVerified = true;

  @override
  String get name {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get phoneNumber {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get photoURL {
    throw UnimplementedError("The authentication function is not implemented.");
  }

  @override
  String get userId => Config.uid;
}
